"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.awsProfileMiddlewareOptions = exports.awsProfileMiddleware = void 0;
const credential_provider_node_1 = require("@aws-sdk/credential-provider-node");
const awsProfileMiddleware = (argv) => {
    const profile = typeof argv.profile === 'string' ? argv.profile : undefined;
    if (profile) {
        const client = argv.client;
        client.output.debug(`Using AWS profile ${profile}`);
    }
    return (0, credential_provider_node_1.defaultProvider)({
        profile,
    });
};
exports.awsProfileMiddleware = awsProfileMiddleware;
const awsProfileMiddlewareOptions = {
    profile: {
        type: 'string',
        description: 'AWS profile that should be used for authentication with the API endpoint.',
        alias: 'awsProfile',
    },
};
exports.awsProfileMiddlewareOptions = awsProfileMiddlewareOptions;
