"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createSpinner = void 0;
const ansi_escapes_1 = __importDefault(require("ansi-escapes"));
const chalk_1 = __importDefault(require("chalk"));
const ora_1 = __importDefault(require("ora"));
const dotsSpinner = {
    frames: ['.', '..', '...'],
    interval: 200,
};
function eraseLines(numberOfLines) {
    return ansi_escapes_1.default.eraseLines(numberOfLines);
}
function createSpinner(message, delay = 300) {
    let spinner;
    const timeout = setTimeout(() => {
        spinner = (0, ora_1.default)({
            spinner: dotsSpinner,
            prefixText: chalk_1.default.gray(message),
            color: 'gray',
        });
        spinner.start();
    }, delay);
    const stop = () => {
        clearTimeout(timeout);
        if (spinner) {
            spinner.stop();
            spinner = null;
            eraseLines(1);
        }
    };
    return stop;
}
exports.createSpinner = createSpinner;
