"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMainCommand = void 0;
const chalk_1 = __importDefault(require("chalk"));
const global_1 = require("../middleware/global");
const alias_1 = require("./alias");
const build_1 = require("./build");
const deploy_1 = require("./deploy");
const deployment_1 = require("./deployment");
const CLI_TITLE = 'milliVolt CLI';
function createMainCommand(globalYargs) {
    globalYargs
        .strict()
        .options(global_1.globalMiddlewareOptions)
        .middleware(global_1.globalMiddleware)
        .demandCommand()
        .showVersion((message) => console.log(chalk_1.default.gray `${CLI_TITLE} ${message}\n`))
        .hide('verbose');
    const yargs = globalYargs;
    (0, alias_1.createAliasCommand)(yargs);
    (0, build_1.createBuildCommand)(yargs);
    (0, deploy_1.createDeployCommand)(yargs);
    (0, deployment_1.createDeploymentCommand)(yargs);
    return yargs;
}
exports.createMainCommand = createMainCommand;
