"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeRoutesByPrefix = void 0;
function removeRoutesByPrefix(routes, prefix) {
    const escapedPrefix = prefix.replace(/[|\\{}()[\]^$+*?.]/g, '\\$&');
    const matcher = new RegExp(`^\\^?\\/?\\/${escapedPrefix}`);
    return routes.filter(({ src }) => {
        if (src && src.match(matcher)) {
            return false;
        }
        return true;
    });
}
exports.removeRoutesByPrefix = removeRoutesByPrefix;
